package com.fp.persistence.plog.log;

import javax.persistence.Entity;
import java.sql.Timestamp;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TLOGHEADER*/
@Entity(name="TlogHeader")
@Table(name="TLOGHEADER")
public class TlogHeader extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TlogHeader
*/
@Id
@Column(name="JOURNALID" ,nullable=false, updatable=false)
private String pk;
@Column(name="ACCOUNTINGDATE", nullable=true)

/**
* Fecha contable en la que se ejecuta la transaccion
*/
private Timestamp accountingdate;

@Column(name="TRANSACTIONMODULE", nullable=false)

/**
* Modulo al que pertence la transaccion
*/
private String transactionmodule;

@Column(name="TRANSACTIONCODE", nullable=false)

/**
* Codigo de transaccion dentro del modulo
*/
private Integer transactioncode;

@Column(name="TRANSACTIONVERSION", nullable=false)

/**
* Version de transaccion
*/
private Integer transactionversion;

@Column(name="REALDATE", nullable=true)

/**
* Fecha real de ejecucion de una transaccion
*/
private Timestamp realdate;

@Column(name="COMPANYCODE", nullable=true)

/**
* Codigo de compania
*/
private Integer companycode;

@Column(name="BRANCHCODE", nullable=true)

/**
* Codigo de sucursal de ejecucion de la transaccion.
*/
private Integer branchcode;

@Column(name="OFFICECODE", nullable=true)

/**
* Codigo de oficina de ejecucion de la transaccion 
*/
private Integer officecode;

@Column(name="USERCODE", nullable=true)

/**
* Codigo de usuario que ejecuta la transaccion
*/
private String usercode;

@Column(name="ADITIONALDATA", nullable=true)

/**
* Texto libre
*/
private String aditionaldata;

/**Contructor por defecto*/
public TlogHeader(){
}
/**Contructor de TlogHeader
@param pPk Clave Primaria del entity
@param pTransactionmodule Modulo al que pertence la transaccion
@param pTransactioncode Codigo de transaccion dentro del modulo
@param pTransactionversion Version de transaccion
*/
public TlogHeader(String pPk,String pTransactionmodule,Integer pTransactioncode,Integer pTransactionversion){
 this();
 pk=pPk;
 transactionmodule=pTransactionmodule;
 transactioncode=pTransactioncode;
 transactionversion=pTransactionversion;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TlogHeader
*/
public static TlogHeader find(EntityManager pEntityManager,Object pKey) throws Exception{
    TlogHeader obj = pEntityManager.find(TlogHeader.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TlogHeader
@return El objeto que referencia a la Clave primaria de TlogHeader
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TlogHeader
@param pPk El objeto que referencia a la nueva Clave primaria de TlogHeader
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de accountingdate
@return valor de accountingdate*/
public Timestamp getAccountingdate(){
  return accountingdate;
}
/**Fija el valor de accountingdate
@param pAccountingdate nuevo Valor de accountingdate*/
public void setAccountingdate(Timestamp pAccountingdate){
  accountingdate=pAccountingdate;
}

/**Obtiene el valor de transactionmodule
@return valor de transactionmodule*/
public String getTransactionmodule(){
  return transactionmodule;
}
/**Fija el valor de transactionmodule
@param pTransactionmodule nuevo Valor de transactionmodule*/
public void setTransactionmodule(String pTransactionmodule){
  transactionmodule=pTransactionmodule;
}

/**Obtiene el valor de transactioncode
@return valor de transactioncode*/
public Integer getTransactioncode(){
  return transactioncode;
}
/**Fija el valor de transactioncode
@param pTransactioncode nuevo Valor de transactioncode*/
public void setTransactioncode(Integer pTransactioncode){
  transactioncode=pTransactioncode;
}

/**Obtiene el valor de transactionversion
@return valor de transactionversion*/
public Integer getTransactionversion(){
  return transactionversion;
}
/**Fija el valor de transactionversion
@param pTransactionversion nuevo Valor de transactionversion*/
public void setTransactionversion(Integer pTransactionversion){
  transactionversion=pTransactionversion;
}

/**Obtiene el valor de realdate
@return valor de realdate*/
public Timestamp getRealdate(){
  return realdate;
}
/**Fija el valor de realdate
@param pRealdate nuevo Valor de realdate*/
public void setRealdate(Timestamp pRealdate){
  realdate=pRealdate;
}

/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

/**Obtiene el valor de branchcode
@return valor de branchcode*/
public Integer getBranchcode(){
  return branchcode;
}
/**Fija el valor de branchcode
@param pBranchcode nuevo Valor de branchcode*/
public void setBranchcode(Integer pBranchcode){
  branchcode=pBranchcode;
}

/**Obtiene el valor de officecode
@return valor de officecode*/
public Integer getOfficecode(){
  return officecode;
}
/**Fija el valor de officecode
@param pOfficecode nuevo Valor de officecode*/
public void setOfficecode(Integer pOfficecode){
  officecode=pOfficecode;
}

/**Obtiene el valor de usercode
@return valor de usercode*/
public String getUsercode(){
  return usercode;
}
/**Fija el valor de usercode
@param pUsercode nuevo Valor de usercode*/
public void setUsercode(String pUsercode){
  usercode=pUsercode;
}

/**Obtiene el valor de aditionaldata
@return valor de aditionaldata*/
public String getAditionaldata(){
  return aditionaldata;
}
/**Fija el valor de aditionaldata
@param pAditionaldata nuevo Valor de aditionaldata*/
public void setAditionaldata(String pAditionaldata){
  aditionaldata=pAditionaldata;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TlogHeader))return false;
    TlogHeader that = (TlogHeader) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TlogHeader
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TlogHeader
*/
public Object createInstance(){
 TlogHeader instance=new TlogHeader();	
 return instance;
}
/**Clona la entidad TlogHeader
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TlogHeader p=(TlogHeader)this.clone();
  return p;
}
}
